-- Useful music functions

function musicload(vol)   -- Initial declarations
  mTRACK, gTRACK, gFADEIN, gFADEOUT = {}, 1, 0, 0
  mTRACK[1], mTRACK[2] = {}, {}
  gSILENCE, gSILENCEMAX = 0, 1800
  gVOLUME = vol or 0.25
end

function musicupdate()  -- Updating the music fade in/out etc.
  if next(mTRACK)~=nil then
    if mTRACK[gTRACK].Music~=nil then       -- Fade in music
      if mTRACK[gTRACK].Music:isPlaying() then
        gSILENCE = 0
        if mTRACK[gTRACK].FadeIn == true then                     
          gFADEIN = gFADEIN + 1
          if gFADEIN > 2/gVOLUME then
            gFADEIN = 0
            mTRACK[gTRACK].Music:setVolume(mTRACK[gTRACK].Music:getVolume()+0.01)
            if mTRACK[gTRACK].Music:getVolume()>gVOLUME then
              mTRACK[gTRACK].FadeIn = false
              mTRACK[gTRACK].Music:setVolume(gVOLUME)
            end
          end
        end
      else gSILENCE = gSILENCE + 1 end
      if gSILENCE >= gSILENCEMAX then musicplay(mTRACK[gTRACK].Song) end
    end
    if mTRACK[3-gTRACK].Music~=nil then   -- Fade out music
      if mTRACK[3-gTRACK].FadeOut == true then
        gFADEOUT = gFADEOUT + 1
        if gFADEOUT > 1.25/gVOLUME then
          gFADEOUT = 0
          mTRACK[3-gTRACK].Music:setVolume(mTRACK[3-gTRACK].Music:getVolume()-0.01)
          if mTRACK[3-gTRACK].Music:getVolume()<0.02 then
            mTRACK[3-gTRACK].FadeOut = false
            mTRACK[3-gTRACK].Music:setVolume(0)
            mTRACK[3-gTRACK].Music:stop()
          end
        end
      end
    end
  end
end

function musicplay(m, loop)
  local alreadyplaying = false
  loop = loop or "Yes"
  if love.filesystem.getInfo("music/music"..m..".mp3", "file") then
    gSILENCE = 0
    if next(mTRACK[gTRACK])~=nil then
      if mTRACK[gTRACK].Song == m then 
        alreadyplaying = true
        mTRACK[gTRACK].FadeOut = false
        if mTRACK[gTRACK].Music:isPlaying() then 
          mTRACK[gTRACK].Music:setVolume(gVOLUME)
          mTRACK[gTRACK].FadeIn = false
        else
          mTRACK[gTRACK].FadeIn = true
          mTRACK[gTRACK].Music:setVolume(0)
          mTRACK[gTRACK].Music:play()
          if loop == "Yes" then mTRACK[gTRACK].Music:setLooping(true)
          else mTRACK[gTRACK].Music:setLooping(false) end
        end
      else mTRACK[gTRACK].FadeOut = true end
    end
    if alreadyplaying == false then
      gTRACK = 3 - gTRACK
      if next(mTRACK[gTRACK])~=nil then
        if mTRACK[gTRACK].Music:isPlaying() then mTRACK[gTRACK].Music:stop() end
      end
      mTRACK[gTRACK].Music = love.audio.newSource("music/music"..m..".mp3", "stream")
      mTRACK[gTRACK].Song = m
      mTRACK[gTRACK].FadeIn = true
      mTRACK[gTRACK].FadeOut = false
      mTRACK[gTRACK].Music:setVolume(0)
      mTRACK[gTRACK].Music:play()
      if loop == "Yes" then mTRACK[gTRACK].Music:setLooping(true)
      else mTRACK[gTRACK].Music:setLooping(false) end
    end
  end
end

function musicsetvolume(vol)
  local i
  if next(mTRACK)~=nil then
    for i = 1, #mTRACK, 1 do
      if mTRACK[i].Music ~= nil then mTRACK[i].Music:setVolume(vol) end
    end
  end
end

function musicstop()
  love.audio.stop()
  mTRACK[1], mTRACK[2] = {}, {}
end